## frogatto 1.1+dfsg

=== debian/changelog ===
frogatto (1.1+dfsg-4ubuntu1) oneiric; urgency=low

  * Fix link order to list libraries after the objects that require them
    (LP: #771073).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 14 Sep 2011 12:49:26 +0100

frogatto (1.1+dfsg-4) unstable; urgency=low

  * Thoroughly disable ccache.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 19 Jun 2011 17:19:11 +0400

frogatto (1.1+dfsg-3) unstable; urgency=low

  * Disable ccache.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 19 Jun 2011 16:11:54 +0400

frogatto (1.1+dfsg-2) unstable; urgency=low

  * Replace libglew-dev to libglew1.5-dev in deplist (FTBFS), closes: #630971.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 19 Jun 2011 14:51:21 +0400

frogatto (1.1+dfsg-1) unstable; urgency=low

  * New upstream version, closes: #628753.
  * Attention: new version is incompatible with Your old saves.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 14 Jun 2011 11:20:13 +0400

=== debian/control ===
Source: frogatto
Section: contrib/games
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Standards-Version: 3.9.1
Build-Depends: cdbs, debhelper (>= 7.0),
 libz-dev,
 libsdl1.2-dev (>= 1.2.7),
 libboost-dev (>= 1.35),
 libglew1.5-dev | libglew1.6-dev,
 libsdl-ttf2.0-dev (>= 2.0.8),
 libsdl-mixer1.2-dev (>= 1.2.7),
 libsdl-image1.2-dev (>= 1.2.7),
 libboost-regex-dev (>= 1.35),
 libboost-system-dev (>= 1.35)
Homepage: http://www.frogatto.com/
Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
VCS-Browser: http://git.debian.org/?p=pkg-games/frogatto.git;a=summary
VCS-Git: git+ssh://git.debian.org/git/pkg-games/frogatto.git

Package: frogatto
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 frogatto-data (>= ${UVersion})
Description:  2D platformer game starring a quixotic frog
 Frogatto is a platformer in the style of old arcade, Sega and
 Nintendo games. The world is viewed as a cross-section seen from the
 side, and your character walks and jumps between solid platforms
 whilst fighting monsters.
 .
 This package contains game engine.

## frogatto 1.1.1-maemo1

=== Makefile ===
CC  = gcc
CXX = g++

NEON = -mcpu=cortex-a8 -mfpu=neon -ftree-vectorize -mfloat-abi=soft -ffast-math -fsingle-precision-constant -fno-inline-functions
OPT = -O2 $(NEON) -DTARGET_OS_MAEMO -DSDL_VIDEO_OPENGL_ES -DGLdouble=GLfloat -DSDL_GL_SwapBuffers=SDL_GLES_SwapBuffers

objects = IMG_savepng.o achievements.o background.o blur.o border_widget.o button.o character_editor_dialog.o checkbox.o current_generator.o decimal.o editor_dialogs.o editor_formula_functions.o editor_layers_dialog.o editor_stats_dialog.o editor_variable_info.o collision_utils.o color_utils.o controls.o controls_dialog.o custom_object.o custom_object_callable.o custom_object_functions.o custom_object_type.o debug_console.o dialog.o draw_number.o draw_scene.o draw_tile.o editor.o editor_level_properties_dialog.o entity.o filesystem.o font.o formula.o formula_callable_definition.o formula_constants.o formula_function.o formula_profiler.o formula_tokenizer.o formula_variable_storage.o frame.o framed_gui_element.o game_registry.o geometry.o globals.o graphical_font.o graphical_font_label.o grid_widget.o group_property_editor_dialog.o gui_formula_functions.o gui_section.o i18n.o image_widget.o input.o inventory.o iphone_controls.o joystick.o key.o key_button.o label.o level.o level_logic.o level_object.o level_runner.o level_solid_map.o light.o load_level.o main.o message_dialog.o movement_script.o multi_tile_pattern.o multiplayer.o object_events.o options_dialog.o osso.o package.o particle_system.o pause_game_dialog.o playable_custom_object.o player_info.o powerup.o preferences.o preprocessor.o preview_tileset_widget.o property_editor_dialog.o random.o raster.o raster_distortion.o rectangle_rotator.o scrollbar_widget.o scrollable_widget.o segment_editor_dialog.o settings_dialog.o slider.o solid_map.o sound.o speech_dialog.o stats.o string_utils.o surface_cache.o surface_formula.o surface_palette.o surface_scaling.o surface.o texture.o texture_frame_buffer.o text_entry_widget.o thread.o tile_map.o tileset_editor_dialog.o tooltip.o translate.o utils.o variant.o water.o water_particle_system.o weather_particle_system.o widget.o wml_formula_adapter.o wml_formula_callable.o wml_modify.o wml_node.o wml_parser.o wml_schema.o wml_utils.o wml_writer.o unit_test.o formula_test.o wml_parser_test.o loading_screen.o utility_object_compiler.o utility_object_editor.o utility_render_level.o

server_objects = server.o simple_wml.o

formula_test_objects = filesystem.o formula_function.o formula_tokenizer.o string_utils.o variant.o wml_node.o wml_parser.o wml_utils.o wml_writer.o

wml_modify_test_objects = filesystem.o string_utils.o wml_node.o wml_parser.o wml_utils.o
wml_schema_test_objects = filesystem.o string_utils.o wml_node.o wml_parser.o wml_utils.o

DEFINES=-DNO_EDITOR=1 -DVERSION='"1.1.1"'
LDADD=-lGLES_CM -lSDLmain -lSDL -lSDL_gles `pkg-config --libs gobject-2.0 libosso`

%.o : src/%.cpp
	$(CXX) -DIMPLEMENT_SAVE_PNG -fno-inline-functions -g $(OPT) `sdl-config --cflags` -D_GNU_SOURCE=1 -D_REENTRANT $(DEFINES) -Wnon-virtual-dtor -Wreturn-type -fthreadsafe-statics -c $<

game: $(objects)
	$(CXX) -g $(OPT) -L. -L/sw/lib -L. -D_GNU_SOURCE=1 -D_REENTRANT -Wnon-virtual-dtor -Wreturn-type -L/usr/lib `sdl-config --libs` ${LDADD} -lSDL_image -lpng -lboost_regex-mt -lboost_system-mt -lpthread -fthreadsafe-statics $(objects) /usr/lib/libSDL_mixer.a -o game

osso.o : src/osso.cpp
	g++ -fno-inline-functions -g $(OPT) `pkg-config --cflags gobject-2.0 libosso` -o $@ -c $<

server: $(server_objects)
	$(CXX) -fno-inline-functions -g $(OPT) -L/sw/lib -D_GNU_SOURCE=1 -D_REENTRANT -Wnon-virtual-dtor -Wreturn-type -L/usr/lib `sdl-config --libs` ${SDL_LIBS} -lGL -lGLU -lSDL_image -lSDL_mixer -lboost_regex-mt -lboost_system-mt -lboost_thread-mt -lboost_iostreams-mt -fthreadsafe-statics $(server_objects) -o server

poolalloc.o: src/poolalloc.c
	$(CC) -fno-inline-functions -g $(OPT) `sdl-config --cflags` -D_GNU_SOURCE=1 -D_REENTRANT -Wreturn-type -c src/poolalloc.c

malloc.o: src/malloc.c
	$(CC) -fno-inline-functions -g $(OPT) `sdl-config --cflags` -D_GNU_SOURCE=1 -D_REENTRANT -DUSE_LOCKS=1 -Wreturn-type -c src/malloc.c

formula_test: $(formula_test_objects)
	$(CXX) -O2 -g -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT -DUNIT_TEST_FORMULA -Wnon-virtual-dtor -Wreturn-type -L/usr/lib -lSDL -lGL -lGLU -lSDL_image -lSDL_mixer -lboost_regex src/formula.cpp $(formula_test_objects) -o test

wml_modify_test: $(wml_modify_test_objects)
	$(CXX) -O2 -g -framework Cocoa -I/usr/local/include/boost-1_34 -I/sw/include/SDL -Isrc/ -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT -DUNIT_TEST_WML_MODIFY -Wnon-virtual-dtor -Wreturn-type -L/usr/lib -lboost_regex src/wml_modify.cpp $(wml_modify_test_objects) -o test

wml_schema_test: $(wml_schema_test_objects)
	$(CXX) -O2 -g -framework Cocoa -I/usr/local/include/boost-1_34 -I/sw/include/SDL -Isrc/ -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT -DUNIT_TEST_WML_SCHEMA -Wnon-virtual-dtor -Wreturn-type -L/usr/lib -lboost_regex src/wml_schema.cpp $(wml_schema_test_objects) -o test

update-pot:
	utils/make-pot.sh > po/frogatto.pot

%.po: po/frogatto.pot
	msgmerge $@ po/frogatto.pot -o $@.part
	mv $@.part $@

LINGUAS=de el eo es fr it pl pt_BR ru sk zh_CN ja

update-po:
	(for lang in ${LINGUAS}; do \
		${MAKE} po/$$lang.po ; \
	done)

update-mo:
	(for lang in ${LINGUAS}; do \
		mkdir -p locale/$$lang/LC_MESSAGES ; \
		msgfmt po/$$lang.po -o locale/$$lang/LC_MESSAGES/frogatto.mo ; \
	done)

clean:
	rm -f *.o game

=== debian/changelog ===
frogatto (1.1.1-maemo1) experimental; urgency=low

  * Update to 1.1.1

 -- Philipp Zabel <philipp.zabel@gmail.com>  Tue, 27 Jul 2011 22:15:39 +0200

## frogatto 1.1.1-maemo2

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 NEON = -mcpu=cortex-a8 -mfpu=neon -ftree-vectorize -mfloat-abi=soft -ffast-math -fsingle-precision-constant -fno-inline-functions
 OPT = -O2 $(NEON) -DTARGET_OS_MAEMO -DSDL_VIDEO_OPENGL_ES -DGLdouble=GLfloat -DSDL_GL_SwapBuffers=SDL_GLES_SwapBuffers
 
-objects = IMG_savepng.o achievements.o background.o blur.o border_widget.o button.o character_editor_dialog.o checkbox.o current_generator.o decimal.o editor_dialogs.o editor_formula_functions.o editor_layers_dialog.o editor_stats_dialog.o editor_variable_info.o collision_utils.o color_utils.o controls.o controls_dialog.o custom_object.o custom_object_callable.o custom_object_functions.o custom_object_type.o debug_console.o dialog.o draw_number.o draw_scene.o draw_tile.o editor.o editor_level_properties_dialog.o entity.o filesystem.o font.o formula.o formula_callable_definition.o formula_constants.o formula_function.o formula_profiler.o formula_tokenizer.o formula_variable_storage.o frame.o framed_gui_element.o game_registry.o geometry.o globals.o graphical_font.o graphical_font_label.o grid_widget.o group_property_editor_dialog.o gui_formula_functions.o gui_section.o i18n.o image_widget.o input.o inventory.o iphone_controls.o joystick.o key.o key_button.o label.o level.o level_logic.o level_object.o level_runner.o level_solid_map.o light.o load_level.o main.o message_dialog.o movement_script.o multi_tile_pattern.o multiplayer.o object_events.o options_dialog.o osso.o package.o particle_system.o pause_game_dialog.o playable_custom_object.o player_info.o powerup.o preferences.o preprocessor.o preview_tileset_widget.o property_editor_dialog.o random.o raster.o raster_distortion.o rectangle_rotator.o scrollbar_widget.o scrollable_widget.o segment_editor_dialog.o settings_dialog.o slider.o solid_map.o sound.o speech_dialog.o stats.o string_utils.o surface_cache.o surface_formula.o surface_palette.o surface_scaling.o surface.o texture.o texture_frame_buffer.o text_entry_widget.o thread.o tile_map.o tileset_editor_dialog.o tooltip.o translate.o utils.o variant.o water.o water_particle_system.o weather_particle_system.o widget.o wml_formula_adapter.o wml_formula_callable.o wml_modify.o wml_node.o wml_parser.o wml_schema.o wml_utils.o wml_writer.o unit_test.o formula_test.o wml_parser_test.o loading_screen.o utility_object_compiler.o utility_object_editor.o utility_render_level.o
+objects = IMG_savepng.o achievements.o background.o blur.o border_widget.o button.o character_editor_dialog.o checkbox.o current_generator.o decimal.o editor_dialogs.o editor_formula_functions.o editor_layers_dialog.o editor_stats_dialog.o editor_variable_info.o collision_utils.o color_utils.o controls.o controls_dialog.o custom_object.o custom_object_callable.o custom_object_functions.o custom_object_type.o debug_console.o dialog.o draw_number.o draw_scene.o draw_tile.o editor.o editor_level_properties_dialog.o entity.o filesystem.o font.o formula.o formula_callable_definition.o formula_constants.o formula_function.o formula_profiler.o formula_tokenizer.o formula_variable_storage.o frame.o framed_gui_element.o game_registry.o geometry.o globals.o graphical_font.o graphical_font_label.o grid_widget.o group_property_editor_dialog.o gui_formula_functions.o gui_section.o i18n.o image_widget.o input.o inventory.o iphone_controls.o joystick.o key.o key_button.o label.o level.o level_logic.o level_object.o level_runner.o level_solid_map.o light.o load_level.o main.o message_dialog.o movement_script.o multi_tile_pattern.o multiplayer.o object_events.o options_dialog.o osso.o package.o particle_system.o pause_game_dialog.o playable_custom_object.o player_info.o powerup.o preferences.o preprocessor.o preview_tileset_widget.o property_editor_dialog.o random.o raster.o raster_distortion.o rectangle_rotator.o scrollbar_widget.o scrollable_widget.o segment_editor_dialog.o settings_dialog.o slider.o solid_map.o sound.o speech_dialog.o stats.o string_utils.o surface_cache.o surface_formula.o surface_palette.o surface_scaling.o surface.o texture.o texture_frame_buffer.o text_entry_widget.o thread.o tile_map.o tileset_editor_dialog.o tooltip.o translate.o utils.o variant.o water.o water_particle_system.o weather_particle_system.o widget.o wml_formula_adapter.o wml_formula_callable.o wml_modify.o wml_node.o wml_parser.o wml_schema.o wml_utils.o wml_writer.o unit_test.o formula_test.o wml_parser_test.o loading_screen.o utility_object_compiler.o utility_object_editor.o
 
 server_objects = server.o simple_wml.o

=== SConstruct ===
SConscript("src/SConscript", variant_dir = "build", duplicate = False)

from os.path import splitext
env = Environment()
env["MSGFMT"] = env.WhereIs("msgfmt")
if env["MSGFMT"]:
    for po_file in Glob("po/*.po"):
        lingua, ext = splitext(po_file.name)
	env.Command(Dir("locale").Dir(lingua).Dir("LC_MESSAGES").File("frogatto.mo"), po_file, "$MSGFMT --statistics -o $TARGET $SOURCE")

=== debian/changelog ===
frogatto (1.1.1-maemo2) experimental; urgency=low

  * Rebase to the proper 1.1.1 version
  * Stop packaging unused music, this significantly reduces
    the installed footprint.

 -- Philipp Zabel <philipp.zabel@gmail.com>  Tue, 11 Aug 2011 07:15:39 +0200

## frogatto 1.2+dfsg

=== Makefile ===
CC  = ccache gcc
CXX = ccache g++

OPT = -O2 -fno-inline-functions

include Makefile.common

%.o : src/%.cpp
	$(CXX) -DIMPLEMENT_SAVE_PNG -fno-inline-functions -g $(OPT) `sdl-config --cflags` -D_GNU_SOURCE=1 -D_REENTRANT -Wnon-virtual-dtor -Wreturn-type -fthreadsafe-statics -c $<

game: $(objects)
	$(CXX) -g $(OPT) -D_GNU_SOURCE=1 -D_REENTRANT -Wnon-virtual-dtor -Wreturn-type $(objects) -o game -L. -L/sw/lib -L. -L/usr/lib `sdl-config --libs` -lSDLmain -lSDL -lGL -lGLU -lGLEW -lSDL_image -lSDL_ttf -lSDL_mixer -lpng -lboost_regex-mt -lboost_system-mt -lpthread -fthreadsafe-statics

server: $(server_objects)
	$(CXX) -fno-inline-functions -g $(OPT) -D_GNU_SOURCE=1 -D_REENTRANT -Wnon-virtual-dtor -Wreturn-type -fthreadsafe-statics $(server_objects) -o server -L/sw/lib -L/usr/lib `sdl-config --libs` -lSDLmain -lSDL -lGL -lGLU -lSDL_image -lSDL_ttf -lSDL_mixer -lboost_regex-mt -lboost_system-mt -lboost_thread-mt -lboost_iostreams-mt

formula_test: $(formula_test_objects)
	$(CXX) -O2 -g -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT -DUNIT_TEST_FORMULA -Wnon-virtual-dtor -Wreturn-type src/formula.cpp $(formula_test_objects) -o test -L/usr/lib -lSDL -lGL -lGLU -lSDL_image -lSDL_ttf -lSDL_mixer -lboost_regex

wml_modify_test: $(wml_modify_test_objects)
	$(CXX) -O2 -g -framework Cocoa -I/usr/local/include/boost-1_34 -I/sw/include/SDL -Isrc/ -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT -DUNIT_TEST_WML_MODIFY -Wnon-virtual-dtor -Wreturn-type src/wml_modify.cpp $(wml_modify_test_objects) -o test -L/usr/lib -lboost_regex

wml_schema_test: $(wml_schema_test_objects)
	$(CXX) -O2 -g -framework Cocoa -I/usr/local/include/boost-1_34 -I/sw/include/SDL -Isrc/ -I/usr/include/SDL -D_GNU_SOURCE=1 -D_REENTRANT -DUNIT_TEST_WML_SCHEMA -Wnon-virtual-dtor -Wreturn-type src/wml_schema.cpp $(wml_schema_test_objects) -o test -L/usr/lib -lboost_regex

update-pot:
	utils/make-pot.sh > po/frogatto.pot.bak
	msguniq -F po/frogatto.pot.bak > po/frogatto.pot
	rm po/frogatto.pot.bak

%.po: po/frogatto.pot
	msgmerge $@ po/frogatto.pot -o $@.part
	mv $@.part $@

LINGUAS=ar de el en_GB eo es fr hu_HU id it ja ms_MY nl pl pt_BR ru sk sv tt zh_CN

update-po:
	(for lang in ${LINGUAS}; do \
		${MAKE} po/$$lang.po ; \
	done)

update-mo:
	(for lang in ${LINGUAS}; do \
		mkdir -p locale/$$lang/LC_MESSAGES ; \
		msgfmt po/$$lang.po -o locale/$$lang/LC_MESSAGES/frogatto.mo ; \
	done)

clean:
	rm -f *.o game

=== debian/changelog ===
frogatto (1.2+dfsg-1~ubuntu12.04.1) precise-backports; urgency=low

  * No-change backport to precise (LP: #1005378)

 -- Iain Lane <iain@orangesquash.org.uk>  Mon, 28 May 2012 19:24:57 +0100

frogatto (1.2+dfsg-1) unstable; urgency=low

  [ Vincent Cheng ]
  * Non-maintainer upload.
  * New upstream release. (Closes: #662580)
    - Fix FTBFS with -Wl,--as-needed due to bad link order. (Closes: #641570)
  * Drop +ssh protocol in debian/control Vcs-* fields. (Closes: #669295)
  * Enable build hardening using dpkg-buildflags.
    - Add debian/patches/enable-build-hardening.patch.
  * Remove deprecated Encoding field from desktop menu file (lintian tag
    desktop-entry-contains-encoding-key).
  * Fix debian/watch file to point to latest release hosted on Github.
  * Update to Standards version 3.9.3, no changes required.

  [ Dmitry E. Oboukhov ]
  * Add Vincent Cheng to Uploaders list.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 27 May 2012 09:52:56 +0400

frogatto (1.1+dfsg-4.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add libpng-dev to Build-Depends (closes: #669309). Thanks to Christoph
    Egger for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 28 Apr 2012 14:55:35 +0200

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk

PACKAGE_VERSION 	:= $(shell		\
		dpkg-parsechangelog 		\
	|	grep ^Version 			\
	|	awk '{print $$2}' 		\
	|	sed 's/-[[:digit:]]\+$$//'	\
)

UPSTREAM_CLEAN_VERSION	:= $(shell echo $(PACKAGE_VERSION) | sed 's/[+-].*//' )

DEB_DH_GENCONTROL_ARGS	= -- -VUVersion=$(UPSTREAM_CLEAN_VERSION)

export CCACHE_DISABLE=1

clean::
	find -name \*.o -delete
	find -name \*.mo -delete
	rm -f game frogatto.6

build/frogatto:: frogatto.6
	make update-mo
	make

frogatto.6: debian/frogatto.pod
	pod2man --section=6 $< > $@

tarball:
	cd .. && tar \
		--exclude=debian \
		--exclude=.git \
		-czvf frogatto_$(PACKAGE_VERSION).orig.tar.gz \
		frogatto-$(PACKAGE_VERSION)

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
 https://github.com/frogatto/frogatto/tags .*/tarball/(\d[\d\.]+)

## frogatto 1.3.1%2Bdfsg

=== debian/control ===
Source: frogatto
Section: contrib/games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Standards-Version: 4.6.1
Build-Depends:
 debhelper-compat (= 13),
 libz-dev,
 libpng-dev,
 libsdl1.2-dev (>= 1.2.7),
 libboost-dev (>= 1.35),
 libglew-dev,
 libsdl-ttf2.0-dev (>= 2.0.8),
 libsdl-mixer1.2-dev (>= 1.2.7),
 libsdl-image1.2-dev (>= 1.2.7),
 libboost-regex-dev (>= 1.35),
 libboost-system-dev (>= 1.35),
 libopengl-dev
Homepage: http://www.frogatto.com/
Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>,
	Vincent Cheng <vcheng@debian.org>,
	Martin Quinson <mquinson@debian.org>
Vcs-Git: https://salsa.debian.org/games-team/frogatto.git
Vcs-Browser: https://salsa.debian.org/games-team/frogatto

Package: frogatto
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 fonts-freefont-ttf,
 frogatto-data (>= ${UVersion})
Description: 2D platformer game starring a quixotic frog
 Frogatto is a platformer in the style of old arcade, Sega and
 Nintendo games. The world is viewed as a cross-section seen from the
 side, and your character walks and jumps between solid platforms
 whilst fighting monsters.
 .
 This package contains game engine.

## frogatto 1.3.1+dfsg

=== Makefile ===
#
# Main Makefile, intended for use on Linux/X11 and compatible platforms
# using GNU Make.
#
# It should guess the paths to the game dependencies on its own, except for
# Boost which is assumed to be installed to the default locations. If you have
# installed Boost to a non-standard location, you will need to override CXXFLAGS
# and LDFLAGS with any applicable -I and -L arguments.
#
# The main options are:
#
#   CCACHE           The ccache binary that should be used when USE_CCACHE is
#                     enabled (see below). Defaults to 'ccache'.
#   CXX              C++ compiler comand line.
#   CXXFLAGS         Additional C++ compiler options.
#   OPTIMIZE         If set to 'yes' (default), builds with compiler
#                     optimizations enabled (-O2). You may alternatively use
#                     CXXFLAGS to set your own optimization options.
#   LDFLAGS          Additional linker options.
#   USE_CCACHE       If set to 'yes' (default), builds using the CCACHE binary
#                     to run the compiler. If ccache is not installed (i.e.
#                     found in PATH), this option has no effect.
#

OPTIMIZE=yes
CCACHE?=ccache
USE_CCACHE?=$(shell which $(CCACHE) 2>&1 > /dev/null && echo yes)
ifneq ($(USE_CCACHE),yes)
CCACHE=
endif

ifeq ($(OPTIMIZE),yes)
BASE_CXXFLAGS += -O2
endif

# Initial compiler options, used before CXXFLAGS and CPPFLAGS.
BASE_CXXFLAGS += -g -fno-inline-functions -fthreadsafe-statics -Wnon-virtual-dtor -Werror -Wignored-qualifiers -Wformat -Wswitch

# Compiler include options, used after CXXFLAGS and CPPFLAGS.
INC := $(shell pkg-config --cflags x11 sdl glu glew SDL_image libpng zlib)

# Linker library options.
LIBS := $(shell pkg-config --libs x11 ) -lSDLmain \
	$(shell pkg-config --libs sdl glu glew SDL_image libpng zlib) -lSDL_ttf -lSDL_mixer

include Makefile.common

%.o : src/%.cpp
	$(CCACHE) $(CXX) \
		$(BASE_CXXFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INC) -DIMPLEMENT_SAVE_PNG \
		-c $<
	$(CXX) $(BASE_CXXFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INC) -DIMPLEMENT_SAVE_PNG -MM $< > $*.d
	@mv -f $*.d $*.d.tmp
	@sed -e 's|.*:|$*.o:|' < $*.d.tmp > $*.d
	@sed -e 's/.*://' -e 's/\\$$//' < $*.d.tmp | fmt -1 | \
		sed -e 's/^ *//' -e 's/$$/:/' >> $*.d
	@rm -f $*.d.tmp

game: $(objects)
	$(CCACHE) $(CXX) \
		$(BASE_CXXFLAGS) $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) $(INC) \
		$(objects) -o game \
		$(LIBS) -lboost_regex-mt -lboost_system-mt -lpthread -fthreadsafe-statics

# pull in dependency info for *existing* .o files
-include $(objects:.o=.d)

server: $(server_objects)
	$(CCACHE) $(CXX) \
		$(BASE_CXXFLAGS) $(LDFLAGS) $(CXXFLAGS) $(CPPFLAGS) \
		$(server_objects) -o server \
		$(LIBS) -lboost_regex-mt -lboost_system-mt -lboost_thread-mt -lboost_iostreams-mt

clean:
	rm -f *.o *.d game
	
assets:
	./game --utility=compile_levels
	./game --utility=compile_objects

=== src/CMakeLists.txt ===
#
# This file contains lists of object files for our build targets.
# Please keep every file in separate lines to make diff and patching easier.
#

set( FROGATTO_SRC_PLATFORM "" )
set( FROGATTO_LIB_PLATFORM "" )
if( WIN32 )
    set( FROGATTO_SRC_PLATFORM frogatto-resouces.rc )
    set( FROGATTO_LIB_PLATFORM shlwapi.lib pthreadVC2.lib glew32.lib )
endif( WIN32 )

# Game engine
add_executable( frogatto 
	IMG_savepng.cpp
	achievements.cpp
	animation_preview_widget.cpp
    asserts.cpp
	background.cpp
	blur.cpp
	border_widget.cpp
	button.cpp
	character_editor_dialog.cpp
	checkbox.cpp
	checksum.cpp
	code_editor_widget.cpp
	code_editor_dialog.cpp
	current_generator.cpp
	decimal.cpp
	editor_dialogs.cpp
	editor_formula_functions.cpp
	editor_layers_dialog.cpp
	editor_stats_dialog.cpp
	editor_variable_info.cpp
	external_text_editor.cpp
    clipboard.cpp
	collision_utils.cpp
	color_utils.cpp
	controls.cpp
	controls_dialog.cpp
	custom_object.cpp
	custom_object_callable.cpp
	custom_object_functions.cpp
	custom_object_type.cpp
	debug_console.cpp
	dialog.cpp
	draw_number.cpp
	draw_scene.cpp
	draw_tile.cpp
	editor.cpp
	editor_level_properties_dialog.cpp
	entity.cpp
	filesystem.cpp
	font.cpp
	formula.cpp
	formula_callable_definition.cpp
	formula_constants.cpp
	formula_function.cpp
    formula_function_registry.cpp
	formula_profiler.cpp
	formula_tokenizer.cpp
	formula_variable_storage.cpp
	frame.cpp
	framed_gui_element.cpp
	game_registry.cpp
	geometry.cpp
	globals.cpp
	graphical_font.cpp
	graphical_font_label.cpp
	grid_widget.cpp
	group_property_editor_dialog.cpp
	gui_formula_functions.cpp
	gui_section.cpp
	i18n.cpp
	image_widget.cpp
	input.cpp
	iphone_controls.cpp
	joystick.cpp
	json_parser.cpp
	json_tokenizer.cpp
	key.cpp
	key_button.cpp
	label.cpp
	level.cpp
	level_logic.cpp
	level_object.cpp
	level_runner.cpp
	level_solid_map.cpp
	light.cpp
	load_level.cpp
	main.cpp
	md5.cpp
	message_dialog.cpp
    module.cpp
	movement_script.cpp
	multi_tile_pattern.cpp
	multiplayer.cpp
	object_events.cpp
	options_dialog.cpp
	package.cpp
	particle_system.cpp
	pathfinding.cpp
	pause_game_dialog.cpp
	playable_custom_object.cpp
	player_info.cpp
	preferences.cpp
	preprocessor.cpp
	preview_tileset_widget.cpp
	property_editor_dialog.cpp
	random.cpp
	raster.cpp
	raster_distortion.cpp
	rectangle_rotator.cpp
	scrollbar_widget.cpp
	scrollable_widget.cpp
	segment_editor_dialog.cpp
	settings_dialog.cpp
	slider.cpp
	solid_map.cpp
	sound.cpp
	speech_dialog.cpp
	stats.cpp
	string_utils.cpp
	surface_cache.cpp
	surface_formula.cpp
	surface_palette.cpp
	surface_scaling.cpp
	surface.cpp
    text_editor_widget.cpp
    text_entry_widget.cpp
	texture.cpp
	texture_frame_buffer.cpp
	text_entry_widget.cpp
	thread.cpp
	tile_map.cpp
	tileset_editor_dialog.cpp
	tooltip.cpp
	translate.cpp
	utils.cpp
	variant.cpp
	variant_callable.cpp
	variant_utils.cpp
	water.cpp
	water_particle_system.cpp
	weather_particle_system.cpp
	widget.cpp
	unit_test.cpp
	formula_test.cpp
	loading_screen.cpp
	utility_object_compiler.cpp
	utility_query.cpp
	utility_render_level.cpp
    vector_text.cpp
    wml_formula_callable.cpp
    ${FROGATTO_SRC_PLATFORM} )

target_link_libraries( frogatto ${OPENGL_LIBRARIES} ${SDL_LIBRARY} ${SDLIMAGE_LIBRARY} ${SDLTTF_LIBRARY} ${SDLMIXER_LIBRARY} ${FROGATTO_LIB_PLATFORM} )

# Server
add_executable( server 
    server.cpp 
    simple_wml.cpp )

#
## Unit test
#add_executable( formula_test_objects 
#    filesystem.cpp
#    formula_function.cpp
#    formula_tokenizer.cpp
#    string_utils.cpp
#    variant.cpp
#    wml_node.cpp
#    wml_parser.cpp 
#    wml_utils.cpp
#    wml_writer.cpp )
#    
## Unit test
#add_executable( wml_modify_test_objects 
#	filesystem.cpp
#	string_utils.cpp
#	wml_node.cpp
#	wml_parser.cpp
#	wml_utils.cpp )
#
## Unit test
#add_executable( wml_schema_test_objects
#	filesystem.cpp
#	string_utils.cpp
#	wml_node.cpp
#	wml_parser.cpp
#	wml_utils.cpp )
#

=== debian/changelog ===
frogatto (1.3.1+dfsg-7) unstable; urgency=medium

  * Team Upload
  * d/control: fix Maintainer <-> Uploaders inversion
  * Remove old Debian menu file
  * Reformat d/control with debputy

  [ Martin Quinson ]
  * Use secure URI in Homepage field.
  * Update watch file format version to 4.

 -- Alexandre Detiste <tchet@debian.org>  Mon, 21 Apr 2025 17:05:59 +0200

frogatto (1.3.1+dfsg-6) unstable; urgency=medium

  * Fix a FTBFS by using GLES2 instead of libopengl-dev (Closes: #1010804).
    Thanks Reiner Herrmann for the patch.
  * Drop cdbs and use debhelper only; Bump debhelper to v13.
  * Bump Standards-Version to 4.6.1 (move to dh)
  * d/p/commit-824cadd: commit picked upstream to hopefully fix some
    segfaults.

 -- Martin Quinson <mquinson@debian.org>  Thu, 25 Aug 2022 22:42:15 +0200

frogatto (1.3.1+dfsg-5) unstable; urgency=low

  * New patch to fix a FTBFS with Boost 1.71 (Closes: #959480).
    Thanks Giovanni Mascellani for the report and the patch.
  * Trim trailing whitespace.
  * Bump debhelper from deprecated 9 to 10.
  * Change priority extra to priority optional.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Martin Quinson <mquinson@debian.org>  Fri, 05 Jun 2020 22:23:41 +0200

frogatto (1.3.1+dfsg-4) unstable; urgency=medium

  * Fix gcc7 FTBFS (forbids comparison between pointer and integer),
    closes: #871230.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 16 Aug 2017 11:23:08 +0300

frogatto (1.3.1+dfsg-3) unstable; urgency=low

  [ Martin Quinson ]
  * Change the menu section from 'Games/Action' to 'Games/Advantures'
  * d/p/gcc6: fix compilation with gcc 6 (Closes: #833775)
  * d/control: Update to Standards version 3.9.8, no changes required.

  [ Vincent Cheng ]
  * Update email address.

 -- Martin Quinson <mquinson@debian.org>  Fri, 19 Aug 2016 00:23:24 +0200

frogatto (1.3.1+dfsg-2) unstable; urgency=low

  * Add myself to the uploaders -- oops
  * Fix a FTBFS with boost 1.53 (Closes: #709248)
    Thanks to dmitrij.ledkov@ubuntu.com for the report and for the patch

 -- Martin Quinson <mquinson@debian.org>  Wed, 22 May 2013 01:36:39 +0200

frogatto (1.3.1+dfsg-1) unstable; urgency=low

  * Team upload.

  [ Vincent Cheng ]
  * New upstream release (Closes: #697480).
  * Remove all patches; implement no ccache, build hardening in debian/rules.
  * Add build-dep on libglew-dev instead of libglew1.5-dev | libglew1.6-dev.
  * Enable parallel build.
  * Update debian/watch, thanks to Bart Martens.
  * Update to Standards version 3.9.4, no changes required.

  [ Martin Quinson ]
  * Use the FreeFont instead of Ubuntu one, as the later one is not
    compatible with DFSG (see e.g. #603157). This also fixes an issue
    in loading the editor, as a relative path was hardcoded then.
  * Depend on fonts-freefont-ttf that provide the font we use
  * Translate the comment of desktop file in French.
  * Switch to debhelper compatibility level 9.

 -- Martin Quinson <mquinson@debian.org>  Sat, 26 Jan 2013 23:31:10 +0100

=== debian/control ===
Source: frogatto
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Dmitry E. Oboukhov <unera@debian.org>,
 Vincent Cheng <vcheng@debian.org>,
 Martin Quinson <mquinson@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libboost-dev (>= 1.35),
 libboost-regex-dev (>= 1.35),
 libboost-system-dev (>= 1.35),
 libglew-dev,
 libopengl-dev,
 libpng-dev,
 libsdl-image1.2-dev (>= 1.2.7),
 libsdl-mixer1.2-dev (>= 1.2.7),
 libsdl-ttf2.0-dev (>= 2.0.8),
 libsdl1.2-dev (>= 1.2.7),
 libz-dev,
Standards-Version: 4.7.2
Homepage: https://www.frogatto.com/
Vcs-Git: https://salsa.debian.org/games-team/frogatto.git
Vcs-Browser: https://salsa.debian.org/games-team/frogatto
X-Style: black

Package: frogatto
Architecture: any
Depends:
 fonts-freefont-ttf,
 frogatto-data (>= ${UVersion}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: 2D platformer game starring a quixotic frog
 Frogatto is a platformer in the style of old arcade, Sega and
 Nintendo games. The world is viewed as a cross-section seen from the
 side, and your character walks and jumps between solid platforms
 whilst fighting monsters.
 .
 This package contains game engine.

=== debian/rules ===
#!/usr/bin/make -f

# See 'man dpkg-architecture'
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

CMAKE_FLAGS=

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O0
  CMAKE_FLAGS += -Denable_compile_optimizations=off
else
  CFLAGS += $(shell dpkg-buildflags --get CFLAGS)
  # build with -O3 everywhere since it is upstream policy to do so.
  CFLAGS += -O3
endif

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  CMAKE_FLAGS += -Denable_documentation=off
endif

export DEB_BUILD_MAINT_OPTIONS += hardening=+all

export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS) -DUSE_GLES2
export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_build: frogatto.6
	dh_auto_build USE_CCACHE=no

frogatto.6: debian/frogatto.pod
	pod2man --section=6 $< > $@

override_dh_clean:
	dh_clean
	find -name \*.o -delete
	find -name \*.mo -delete
	find -name \*.d -delete
	rm -f game frogatto.6

override_dh_gencontrol:
	dh_gencontrol -- -VUVersion=$(DEB_VERSION_UPSTREAM)

tarball:
	cd .. && tar \
		--exclude=debian \
		--exclude=.git \
		-czvf frogatto_$(PACKAGE_VERSION).orig.tar.gz \
		frogatto-$(PACKAGE_VERSION)

=== debian/watch ===
version=4
opts=dversionmangle=s/\+(dfsg|ds|deb)\d*$// https://github.com/frogatto/frogatto/tags .*/v?(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
